'use strict';

exports.__esModule = true;
exports.parseCSS = parseCSS;

var _parse = require('styled-components/lib/vendor/postcss-safe-parser/parse');

var _parse2 = _interopRequireDefault(_parse);

var _postcssNested = require('styled-components/lib/vendor/postcss-nested');

var _postcssNested2 = _interopRequireDefault(_postcssNested);

var _stringify = require('styled-components/lib/vendor/postcss/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _autoprefix = require('styled-components/lib/utils/autoprefix');

var _autoprefix2 = _interopRequireDefault(_autoprefix);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function parseCSS(css) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    nested: true
  };

  // todo - handle errors
  var root = (0, _parse2.default)(css);
  if (options.nested !== false) (0, _postcssNested2.default)(root);
  (0, _autoprefix2.default)(root);

  root.walkDecls(function (decl) {
    if (decl.prop === 'name') decl.remove();
  });

  return stringifyCSSRoot(root);
}

function stringifyCSSRoot(root) {
  return root.nodes.map(function (node, i) {
    var str = '';
    (0, _stringify2.default)(node, function (x) {
      str += x;
    });
    return str;
  });
}