'use strict';

exports.__esModule = true;

exports.default = function (tag, cls) {
  var vars = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var content = arguments[3];

  if (!tag) {
    throw new Error('You are trying to create a styled element with an undefined component.\nYou may have forgotten to import it.');
  }

  function Styled(props) {
    var className = (0, _index.css)(cls, vars.map(function (v) {
      return v && typeof v === 'function' ? v(props) : v;
    }), content);

    return _react2.default.createElement(tag, Object.assign({}, props, {
      className: props.className ? className + ' ' + props.className : className
    }));
  }

  var _cls$split = cls.split('-'),
      name = _cls$split[0];

  var debugName = name === 'css' ? '' : '.' + name;
  var componentTag = tag.displayName || tag.name || 'Component';
  Styled.displayName = 'styled(' + componentTag + debugName + ')';

  return Styled;
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('./index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }